{$S-,D-,V-
                         LIB  Unit
                         ^^^^^^^^^
                                  by Sergey Kasandrov (c) 1994,95.
                                  
                                  Version 3.00, release 23.06.95.

                        ঠ:

   - । । ⨯  ( CTYPE);
   - 樨  ப;
   - 樨  ࠬ ;
   - 㭪樨, 騥 襥  襥 祭  ;

}

Unit Lib;

Interface

const
                 { ***  TOGGLE  CONSTANTS  *** }

                  Off = False;      On = True;


          { ***  CHARACTER  CLASSIFICATION  TOOLS  *** }

function IsAlNum( C: Char): Boolean;     { '0'..'9', 'A'..'Z', 'a'..'z' }
function IsAlpha( C: Char): Boolean;     { 'A'..'Z', 'a'..'z' }
function IsBetNum( C: Char): Boolean;    { '_', '0'..'9', 'A'..'Z', 'a'..'z'}
function IsBeta( C: Char): Boolean;      { '_', 'A'..'Z', 'a'..'z'}
function IsLower( C: Char): Boolean;     { 'a'..'z' }
function IsUpper( C: Char): Boolean;     { 'A'..'Z' }
function IsDigit( C: Char): Boolean;     { '0'..'9' }
function IsXDigit( C: Char): Boolean;    { '0'..'9', 'A'..'F', 'a'..'f' }
function IsCyril( C: Char): Boolean;     { ''..'', ''..'', ''..'' }
function IsCyrUpper( C: Char): Boolean;  { ''..'' }
function IsCyrLower( C: Char): Boolean;  { ''..'', ''..'' }


                { ***  STRING  TOOLS  *** }

const
      BreakDecade: Char = '3';           {  室  21  }

const
      LatTab : String[11] = 'ABCEHKMOPTX';
      CyrTab : String[11] = '';

type
      DateStr = String[8];
      LongDateStr = String[10];

function  Str2Asc( S: String): String;               { String -> Asciiz }
function  Asc2Str( S: String): String;               { Asciiz -> String }
function  Replicate( C: Char; Count: Byte): String;  { ( 'A', 3) -> 'AAA'}
procedure FillStr( var S: String; C: Char);          { ( 'ABC', 'A') -> 'AAA'}

                       {  ࠣ T 稭  樨 I  S;
                                                T ࠭ ᫨ I>0 }
procedure UpdateProc( S: String; var T: String; I: Byte);

                        {  墮 ப T  S,  T ࠭ }
procedure RUpdateProc( S: String; var T: String);

                         { True, ᫨ ப   ⮨  ஡ }
function  IsBlank( S: String): Boolean;

                                      { ਢ   孥 ॣ }
function  Upper( S: String): String;
procedure UpperProc( var S: String);

                                       { ਢ    ॣ }
function  Lower( S: String): String;
procedure LowerProc( var S: String);

                                   { ਢ ਫ  孥 ॣ }
function  CyrUpper( S: String): String;

                          { ਢ   ਫ  孥 ॣ }
function  AllUpper( S: String): String;

                                           {  騥 ஡ ப }
function  LTrim( S: String): String;
procedure LTrimProc( var S: String);

                                         {  墮⮢ ஡ ப }
function  RTrim( S: String): String;
procedure RTrimProc( var S: String);

                               {  騥  墮⮢ ஡ ப }
function  AllTrim( const S: String): String;

                               {  騥 ஡    }
function  PadL( S: String; L: Byte): String;
procedure PadLProc( var S: String; L: Byte);

                             {  墮⮢ ஡    }
function  PadR( S: String; L: Byte): String;
procedure PadRProc( var S: String; L: Byte);

                                    {  騥  墮⮢ ஡ }
function  PadC( const S: String; L: Byte): String;

                                {  騥     }
function  PadLChar( S: String; L: Byte; C: Char): String;
procedure PadLCharProc( var S: String; L: Byte; C: Char);

                                            { 16-筮 ।⠢  }
function  HexByte( B: Byte): String;
                                            { 16-筮 ।⠢ ᫮ }
function  HexWord( W: Word): String;

                                             { (' 1 0', ' ', '0') -> '0100' }
function  ChrTran( S: String; OldCh, NewCh: Char): String;
procedure ChrTranProc( var S: String; OldCh, NewCh: Char);

                                             { 'A102' -> '201A' }
function  SwapStr( S: String): String;

                                             { '  A10 ' -> 'A10   ' }
function  LShift( S: String): String;

                                             { '  A10 ' -> '   A10' }
function  RShift( S: String): String;

function CtoD( const St: DateStr): DateStr;     { '15.05.95'   -> '19950515' }
function StoD( const St: LongDateStr): DateStr; { '15.05.1995' -> '19950515' }
function DtoC( S: DateStr): DateStr;            { '19950515'   -> '15.05.95' }
function DtoS( S: DateStr): LongDateStr;        { '19950515' -> '15.05.1995' }
function DtoM( const St: DateStr): Word;        { '19950515' -> 1995*12+5-1  }
function MtoD( M: Word): DateStr;               { 1995*12+5-1 -> '19950501'  }

                                              {    ਫ }
function Lat2Cyr( S: String): String;

function FixedStr( St: String; DecPlaces: Byte):String;

function BtoS( B: Byte; Size: Byte): String;
function StoB( const S: String): Byte;
function WtoS( W: Word; Size: Byte): String;
function StoW( const S: String): Word;
function LtoS( L: LongInt; Size: Byte): String;
function StoL( const S: String): LongInt;



                { ***  RAM TOOLS  *** }

                                          { ࠢ ᮤন ஢ }
function  IsEqual( var Buf1, Buf2; Count: Word): Boolean;

                                          { ࠢ ᮤন ஢ }
function  Compare( var Buf1, Buf2; Count: Word): Integer;



               { ***   MIN & MAX  TOOLS   *** }

function MaxByte( B1, B2: Byte): Byte;           { max( a,b) }
function MaxWord( W1, W2: Word): Word;
function MaxInt( I1, I2: Integer): Integer;
function MinByte( B1, B2: Byte): Byte;           { min( a,b) }
function MinWord( W1, W2: Word): Word;
function MinInt( I1, I2: Integer): Integer;


Implementation


             { ***  INTERNAL  NEAR  CALLS  *** }

procedure UpCasePrim; near; assembler;
   asm
            cmp     al,'a'
            jb      @@Done
            cmp     al,'z'
            ja      @@Done
            and     al,0dfh
@@Done:
   end;


procedure LoCasePrim; near; assembler;
   asm
            cmp     al,'A'
            jb      @@Done
            cmp     al,'Z'
            ja      @@Done
            or      al,20h
@@Done:
   end;


procedure CyrUpCasePrim; near; assembler;
   asm
            cmp     al,''
            jb      @@Skip
            cmp     al,''
            jbe     @@UpCase
            cmp     al,''
            jb      @@Skip
            cmp     al,''
            ja      @@Skip
            sub     al,30h
@@UpCase:
            sub     al,20h
@@Skip:
   end;


procedure AllUpCasePrim; near; assembler;
   asm
            cmp     al,'a'
            jb      @@Done
            cmp     al,'z'
            jbe     @@UpCase
            cmp     al,''
            jb      @@Done
            cmp     al,''
            jbe     @@UpCase
            cmp     al,''
            jb      @@Done
            cmp     al,''
            ja      @@Done
            sub     al,30h
@@UpCase:
            sub     al,20h
@@Done:
   end;



          { ***  CHARACTER  CLASSIFICATION  TOOLS  *** }


function IsAlNum( C: Char): Boolean; assembler;
   asm
            xor     ax,ax           { assume False }
            mov     dl,C
            cmp     dl,'0'
            jb      @@False
            cmp     dl,'9'
            jbe     @@True
            and     dl,0dfh         { UpCase }
            cmp     dl,'A'
            jb      @@False
            cmp     dl,'Z'
            ja      @@False
@@True:
            inc     al              { return True }
@@False:
   end;


function IsAlpha( C: Char): Boolean; assembler;
   asm
            xor     ax,ax           { assume False }
            mov     dl,C
            and     dl,0dfh         { UpCase }
            cmp     dl,'A'
            jb      @@Done
            cmp     dl,'Z'
            ja      @@Done
            inc     al              { return True }
@@Done:
   end;


function IsBetNum( C: Char): Boolean; assembler;
   asm
            xor     ax,ax           { assume False }
            mov     dl,C
            cmp     dl,'_'
            je      @@True
            cmp     dl,'0'
            jb      @@False
            cmp     dl,'9'
            jbe     @@True
            and     dl,0dfh         { UpCase }
            cmp     dl,'A'
            jb      @@False
            cmp     dl,'Z'
            ja      @@False
@@True:
            inc     al              { return True }
@@False:
  end;


function IsBeta( C: Char): Boolean; assembler;
   asm
            xor     ax,ax           { assume False }
            mov     dl,C
            cmp     dl,'_'
            je      @@True
            and     dl,0dfh         { UpCase }
            cmp     dl,'A'
            jb      @@False
            cmp     dl,'Z'
            ja      @@False
@@True:
            inc     al              { return True }
@@False:
   end;


function IsLower( C: Char): Boolean; assembler;
   asm
            xor     ax,ax           { assume False }
            mov     dl,C
            cmp     dl,'a'
            jb      @@Done
            cmp     dl,'z'
            ja      @@Done
            inc     al              { return True }
@@Done:
   end;


function IsUpper( C: Char): Boolean; assembler;
   asm
            xor     ax,ax           { assume False }
            mov     dl,C
            cmp     dl,'A'
            jb      @@Done
            cmp     dl,'Z'
            ja      @@Done
            inc     al              { return True }
@@Done:
   end;


function IsDigit( C: Char): Boolean; assembler;
   asm
            xor     ax,ax           { assume False }
            mov     dl,C
            cmp     dl,'0'
            jb      @@Done
            cmp     dl,'9'
            ja      @@Done
            inc     al              { return True }
@@Done:
   end;


function IsXDigit( C: Char): Boolean; assembler;
   asm
            xor     ax,ax           { assume False }
            mov     dl,C
            cmp     dl,'0'
            jb      @@False
            cmp     dl,'9'
            jbe     @@True
            and     dl,0dfh         { UpCase }
            cmp     dl,'A'
            jb      @@False
            cmp     dl,'F'
            ja      @@False
@@True:
            inc     al              { return True }
@@False:
   end;


function IsCyril( C: Char): Boolean; assembler;
   asm
            xor     ax,ax           { assume False }
            mov     dl,C
            cmp     dl,''
            jb      @@False
            cmp     dl,''
            jbe     @@True
            cmp     dl,''
            jb      @@False
            cmp     dl,''
            jbe     @@True
            cmp     dl,''
            jb      @@False
            cmp     dl,''
            ja      @@False
@@True:
            inc     al              { return True }
@@False:
   end;


function IsCyrUpper( C: Char): Boolean; assembler;
   asm
            xor     ax,ax           { assume False }
            mov     dl,C
            cmp     dl,''
            jb      @@Done
            cmp     dl,''
            ja      @@Done
            inc     al              { return True }
@@Done:
   end;


function IsCyrLower( C: Char): Boolean; assembler;
   asm
            xor     ax,ax           { assume False }
            mov     dl,C
            cmp     dl,''
            jb      @@False
            cmp     dl,''
            jbe     @@True
            cmp     dl,''
            jb      @@False
            cmp     dl,''
            ja      @@False
@@True:
            inc     al              { return True }
@@False:
   end;



               { ***  STRING  TOOLS  *** }


function  Str2Asc( S: String): String; assembler;
   asm
            push    ds
            les     di,@Result
            lds     si,S
            cld
            lodsb                   { string length }
            xor     cx,cx
            mov     cl,al
rep         movsb
            xor     al,al
            stosb                   { add zero byte }
            pop     ds
   end;


function  Asc2Str( S: String): String; assembler;
   asm
            push    ds
            les     di,@Result
            push    di
            inc     di
            lds     si,S
            cld
            xor     cx,cx
@@Loop:
            lodsb
            or      al,al
            jz      @@Done
            stosb
            inc     cl
            cmp     cl,255
            jne     @@Loop
@@Done:
            pop     di
            mov     al,cl
            stosb                   { string length }
            pop     ds
   end;


function  Replicate( C: Char; Count: Byte): String; assembler;
   asm
            les     di,@Result
            mov     al,Count
            cld
            stosb                   { length byte }
            mov     cl,al
            xor     ch,ch
            mov     al,C
rep         stosb
   end;


procedure FillStr( var S: String; C: Char); assembler;
   asm
            les     di,S
            mov     cl,es:[di]
            xor     ch,ch
            cld
            inc     di
            mov     al,C
rep         stosb
   end;


procedure UpdateProc( S: String; var T: String; I: Byte); assembler;
   asm
            push    ds
            les     di,T
            mov     cl,es:[di]      { T length }
            mov     al,I
            sub     cl,al
            jb      @@Done          { T length too small }
            xor     ah,ah
            add     di,ax
            xor     ch,ch
            inc     cl
            lds     si,S
            cld
            lodsb
            cmp     cl,al
            jbe     @@Skip          { I+Length(S) too large }
            mov     cl,al
@@Skip:
rep         movsb
@@Done:
            pop     ds
   end;


procedure RUpdateProc( S: String; var T: String); assembler;
   asm
            push    ds
            les     di,T
            lds     si,S
            cld
            lodsb                    { S length }
            xor     dh,dh
            mov     dl,es:[di]       { T length }
            inc     di
            sub     dl,al
            jb      @@Done           { S length too large }
            add     di,dx
            xor     ch,ch
            mov     cl,al
rep         movsb
@@Done:
            pop     ds
   end;


function  IsBlank( S: String): Boolean; assembler;
   asm
            les     di,S
            cld
            mov     cl,es:[di]       { length byte }
            xor     ch,ch
            jcxz    @@True
            inc     di
            mov     al,' '
repe        scasb
            je      @@True
            xor     ax,ax
            jmp     @@Done
@@True:
            mov     ax,1
@@Done:
   end;


function  Upper( S: String): String; assembler;
   asm
            push    ds
            les     di,@Result
            lds     si,S
            cld
            lodsb
            stosb                   { length byte }
            mov     cl,al
            xor     ch,ch
            jcxz    @@Done
@@Loop:
            lodsb
            call    UpCasePrim
            stosb
            loop    @@Loop
@@Done:
            pop     ds
   end;


procedure UpperProc( var S: String); assembler;
   asm
            les     di,S
            cld
            mov     cl,es:[di]
            xor     ch,ch
            jcxz    @@Done
            inc     di
@@Loop:
            mov     al,es:[di]
            call    UpCasePrim
            stosb
            loop    @@Loop
@@Done:
   end;


function  Lower( S: String): String; assembler;
   asm
            push    ds
            les     di,@Result
            lds     si,S
            cld
            lodsb
            stosb                   { length byte }
            mov     cl,al
            xor     ch,ch
            jcxz    @@Done
@@Loop:
            lodsb
            call    LoCasePrim;
            stosb
            loop    @@Loop
@@Done:
            pop     ds
   end;


procedure LowerProc( var S: String); assembler;
   asm
            les     di,S
            cld
            mov     cl,es:[di]
            xor     ch,ch
            jcxz    @@Done
            inc     di
@@Loop:
            mov     al,es:[di]
            call    LoCasePrim
            stosb
            loop    @@Loop
@@Done:
   end;


function  CyrUpper( S: String): String; assembler;
   asm
            push    ds
            les     di,@Result
            lds     si,S
            cld
            lodsb
            stosb                   { length byte }
            mov     cl,al
            xor     ch,ch
            jcxz    @@Done
@@Loop:
            lodsb
            call    CyrUpCasePrim
            stosb
            loop    @@Loop
@@Done:
            pop     ds
   end;


function AllUpper;
   begin
      AllUpper:= CyrUpper( Upper( S));
   end;


function  LTrim( S: String): String; assembler;
   asm
            push    ds
            les     di,@Result
            lds     si,S
            cld
            lodsb
            mov     cl,al
            xor     ch,ch
            jcxz    @@Copy
@@Loop:
            lodsb
            cmp     al,' '
            jne     @@Copy
            loop    @@Loop
@@Copy:
            mov     es:[di],cl          { length byte }
            jcxz    @@Done
            inc     di
            stosb                       { first byte }
            dec     cl
rep         movsb
@@Done:
            pop     ds
   end;


procedure LTrimProc( var S: String); assembler;
   asm
            push    ds
            les     di,S
            lds     si,S
            cld
            lodsb
            mov     cl,al
            xor     ch,ch
            jcxz    @@Copy
@@Loop:
            lodsb
            cmp     al,' '
            jne     @@Copy
            loop    @@Loop
@@Copy:
            mov     es:[di],cl
            jcxz    @@Done
            inc     di
            stosb
            dec     cl
rep         movsb
@@Done:
            pop     ds
   end;


function  RTrim( S: String): String; assembler;
   asm
            push    ds
            les     di,@Result
            lds     si,S
            mov     cl,ds:[si]      { S length }
            xor     ch,ch
            jcxz    @@Copy
            add     si,cx
            std
@@Loop:
            lodsb
            cmp     al,' '
            jne     @@Copy
            loop    @@Loop
@@Copy:
            mov     es:[di],cl     { Result[0] }
            jcxz    @@Done
            add     di,cx
            stosb
            dec     cl
rep         movsb
@@Done:
            pop     ds
   end;


procedure RTrimProc( var S: String); assembler;
   asm
            les     di,S
            mov     cl,es:[di]      { length byte }
            xor     ch,ch
            jcxz    @@Done
            push    di
            add     di,cx
            mov     al,' '
            std
repe        scasb
            je      @@Skip
            inc     cl
@@Skip:
            pop     di
            mov     es:[di],cl
@@Done:
   end;


function AllTrim;
   begin
      AllTrim:= RTrim( LTrim( S));
   end;


function  PadL( S: String; L: Byte): String; assembler;
   asm
            push    ds
            mov     cl,L
            xor     ch,ch
            les     di,@Result
            lds     si,S
            cld
            lodsb                     { S[0] -> al }
            mov     dl,al
            cmp     cl,al
            jbe     @@Skip            { S length too large }
            mov     al,cl
@@Skip:
            stosb                     { Result length }
            sub     cl,dl             { cl - number of pad blanks }
            jbe     @@Copy
            mov     al,' '
rep         stosb
@@Copy:
            mov     cl,dl             { cl - S[0] }
rep         movsb
            pop     ds
   end;


procedure PadLProc( var S: String; L: Byte); assembler;
   asm
            push    ds
            mov     al,L
            xor     ch,ch
            les     di,S
            lds     si,S
            mov     cl,ds:[si]
            cmp     cl,al
            jae     @@Done
            mov     es:[di],al
            xor     ah,ah
            add     di,ax
            add     si,cx
            sub     al,cl
            std
rep         movsb
            mov     cl,al
            mov     al,' '
rep         stosb
@@Done:
            pop     ds
   end;


function  PadR( S: String; L: Byte): String; assembler;
   asm
            push    ds
            mov     dl,L
            xor     ch,ch
            les     di,@Result
            lds     si,S
            cld
            lodsb
            mov     cl,al            { S[0] }
            cmp     dl,al
            jbe     @@Skip
            mov     al,dl
@@Skip:
            stosb                    { Result[0] }
            sub     al,cl
rep         movsb
            mov     cl,al
            mov     al,' '
rep         stosb
            pop     ds
   end;


procedure PadRProc( var S: String; L: Byte); assembler;
   asm
            mov     cl,L
            xor     ch,ch
            les     di,S
            mov     al,es:[di]
            cmp     al,cl
            jae     @@Done
            mov     es:[di],cl
            add     di,cx
            sub     cl,al
            mov     al,' '
            std
rep         stosb
@@Done:
   end;


function  PadC( const S: String; L: Byte): String;
   begin
      PadC:= PadL( PadR( S, ( Byte( S[0])+L) shr 1), L);
   end;


function  PadLChar( S: String; L: Byte; C: Char): String; assembler;
   asm
            push    ds
            mov     cl,L
            xor     ch,ch
            les     di,@Result
            lds     si,S
            cld
            lodsb                     { S[0] -> al }
            mov     dl,al
            cmp     cl,al
            jbe     @@Skip            { S length too large }
            mov     al,cl
@@Skip:
            stosb                     { Result length }
            sub     cl,dl             { cl - number of pad chars }
            jbe     @@Copy
            mov     al,C
rep         stosb
@@Copy:
            mov     cl,dl             { cl - S[0] }
rep         movsb
            pop     ds
   end;


procedure PadLCharProc( var S: String; L: Byte; C: Char); assembler;
   asm
            push    ds
            mov     al,L
            xor     ch,ch
            les     di,S
            lds     si,S
            mov     cl,ds:[si]
            cmp     cl,al
            jae     @@Done
            mov     es:[di],al
            xor     ah,ah
            add     di,ax
            add     si,cx
            sub     al,cl
            std
rep         movsb
            mov     cl,al
            mov     al,C
rep         stosb
@@Done:
            pop     ds
   end;


function HexByte( B: Byte): String; assembler;
   asm
            les     di,@Result
            cld
            mov     al,2
            stosb
            mov     al,B
            mov     ah,al
            mov     cl,4
            shr     al,cl
            and     ax,0f0fh
            cmp     al,9
            jbe     @@Next
            add     al,7
@@Next:
            cmp     ah,9
            jbe     @@Done
            add     ah,7
@@Done:
            add     ax,3030h
            stosw
   end;


function HexWord;
   begin
      HexWord:= HexByte( Hi( W))+HexByte( Lo( W));
   end;


function ChrTran( S: String; OldCh, NewCh: Char): String; assembler;
   asm
            push    ds
            les     di,@Result
            lds     si,S
            cld
            lodsb
            stosb                   { length byte }
            mov     cl,al
            xor     ch,ch
            jcxz    @@Done
@@Loop:
            lodsb
            cmp     al,OldCh
            jne     @@Skip
            mov     al,NewCh
@@Skip:
            stosb
            loop    @@Loop
@@Done:
            pop     ds
   end;


procedure ChrTranProc( var S: String; OldCh, NewCh: Char); assembler;
   asm
            les     di,S
            mov     cl,es:[di]
            xor     ch,ch
            jcxz    @@Done
            cld
            mov     al,OldCh
            mov     ah,NewCh
@@Loop:
            inc     di
            cmp     es:[di],al
            jne     @@Skip
            mov     es:[di],ah
@@Skip:
            loop    @@Loop
@@Done:
   end;


function SwapStr( S: String): String; assembler;
   asm
            push    ds
            les     di,@Result
            lds     si,S
            cld
            lodsb
            stosb                   { length byte }
            xor     ah,ah
            mov     cx,ax
            jcxz    @@Done
            add     si,ax
@@Loop:
            dec     si
            mov     al,ds:[si]
            stosb
            loop    @@Loop
@@Done:
            pop     ds
   end;


function  LShift( S: String): String; assembler;
   asm
            push    ds
            les     di,@Result
            lds     si,S
            cld
            lodsb
            stosb                   { length byte }
            xor     ch,ch
            mov     cl,al
            jcxz    @@Done
            mov     ah,al
@@Loop:
            lodsb
            cmp     al,' '
            jne     @@Copy
            loop    @@Loop
@@Copy:
            dec     si
            sub     ah,cl           { ah = ᫮  ஡ }
rep         movsb
            mov     cl,ah
            mov     al,' '
rep         stosb
@@Done:
            pop     ds
    end;


function  RShift( S: String): String; assembler;
   asm
            push    ds
            les     di,@Result
            lds     si,S
            cld
            lodsb
            stosb                   { length byte }
            xor     ch,ch
            mov     cl,al
            jcxz    @@Done
            mov     ah,al
            std
            add     si,cx
            dec     si
            add     di,cx
            dec     di
@@Loop:
            lodsb
            cmp     al,' '
            jne     @@Copy
            loop    @@Loop
@@Copy:
            inc     si
            sub     ah,cl           { ah = ᫮ 墮⮢ ஡ }
rep         movsb
            mov     cl,ah
            mov     al,' '
rep         stosb
@@Done:
            pop     ds
   end;


function DtoC( S: DateStr): DateStr; assembler;
   asm
            push    ds
            les     di,@Result
            lds     si,S
            cld
            movsb                   { length byte }
            add     si,6
            movsw                   { Day }
            mov     al,'.'
            stosb
            sub     si,4
            movsw                   { Month }
            mov     al,'.'
            stosb
            sub     si,4
            movsw                   { Year }
            pop     ds
   end;


function DtoS( S: DateStr): LongDateStr; assembler;
   asm
            push    ds
            les     di,@Result
            lds     si,S
            cld
            mov     al,10
            stosb                   { Length byte }
            add     si,7
            movsw                   { Day }
            mov     al,'.'
            stosb
            sub     si,4
            movsw                   { Month }
            mov     al,'.'
            stosb
            sub     si,6
            movsw
            movsw                   { Year }
            pop     ds
   end;


function CtoD;
   begin
      CtoD:= '        ';
      if St='  .  .  ' then Exit;
      CtoD[1]:= '1';
      CtoD[2]:= '9';
      if St[7]<= BreakDecade then begin
         CtoD[1]:= '2';
         CtoD[2]:= '0';
      end;
      CtoD[3]:= St[7];
      CtoD[4]:= St[8];
      CtoD[5]:= St[4];
      CtoD[6]:= St[5];
      CtoD[7]:= St[1];
      CtoD[8]:= St[2];
   end;


function StoD;
   begin
      StoD:= '        ';
      if St='  .  .    ' then Exit;
      StoD[1]:= St[7];
      StoD[2]:= St[8];
      StoD[3]:= St[9];
      StoD[4]:= St[10];
      StoD[5]:= St[4];
      StoD[6]:= St[5];
      StoD[7]:= St[1];
      StoD[8]:= St[2];
   end;


function DtoM;
   var Y, M: Word;
       I: Integer;

   begin
      Val( Copy( St, 1, 4), Y, I);
      Val( Copy( St, 5, 2), M, I);
      DtoM:= Y*12+Pred(M);
   end;


function MtoD;
   var YS: String[4];
       MS: String[2];

   begin
      Str( M div 12:4, YS);
      Str( Succ( M mod 12):2, MS);
      if MS[1]=' ' then MS[1]:= '0';
      MtoD:= YS+MS+'01';
   end;


function Lat2Cyr;
   var StLen: Byte absolute S;
       N, M: Byte;

   begin
      N:= 0;
      repeat
         Inc( N);
         ChrTranProc( S, LatTab[N], CyrTab[N]);
      until N=11;
      Lat2Cyr:= S;
   end;


function FixedStr;
   var
      IntPlaces, Size, N, M: Byte;
      StLen: Byte absolute St;
      Minus: Boolean;

   begin
      FixedStr:= St;
      if StLen=0 then Exit;
      N:= 1;
      Minus:= False;

{ 饬 砫 楫  ᫠ }
      while (N<=StLen) and not IsDigit( St[N]) do begin
         if St[N]='-' then Minus:= not Minus;
         Inc( N);
      end;

{ Assertion: N -  砫 楫  }
      IntPlaces:= 0;

{ ⠥ ᫮ ࠧ冷 楫  }
      while (N+IntPlaces<=StLen) and IsDigit( St[N+IntPlaces]) do
         Inc( IntPlaces);

      if IntPlaces=0 {  ᫠ } then begin
         St[StLen]:= '0';
         Inc( IntPlaces);
         Dec( N); 
      end;

{ ᫨  ஡   , 㫨 ᫮ ஡ ࠧ冷
                         ࠢ쭮 । ६ Size };
      if Succ( IntPlaces+Byte( Minus))>=StLen then DecPlaces:=0;
      Size:= IntPlaces+DecPlaces+Byte( Minus)+Byte( DecPlaces>0);
      if Size>StLen then Size:= StLen;
      M:= 0;

{ 砫 ஡ }
      while Size+M<StLen do begin
         Inc( M);
         FixedStr[M]:= ' ';
      end;

{  }
      if Minus then begin
         Inc( M);
         FixedStr[M]:= '-';
      end;

{   }
      repeat
         Inc( M);
         FixedStr[M]:= St[N];
         Inc( N);
         Dec( IntPlaces);
      until IntPlaces=0;

      Inc( M);
      if M>StLen then Exit;

{ ஡  }
      FixedStr[M]:= '.';
      if St[N]<>'.' then repeat
         Inc( M);
         FixedStr[M]:= '0';
      until M=StLen
      else begin
         Inc( M);
         Inc( N);
         while (M<=StLen) and IsDigit( St[N]) do begin
            FixedStr[M]:= St[N];
            Inc( M);
            Inc( N);
         end;
         while M<=StLen do begin
            FixedStr[M]:= '0';
            Inc( M);
         end;
      end;
   end;


function BtoS;
   var St: String;

   begin
      Str( B:Size, St);
      BtoS:= St;
   end;


function StoB;
   var I: Integer;
       B: Byte;

   begin
      Val( S, B, I);
      StoB:= B;
   end;


function WtoS;
   var St: String;

   begin
      Str( W:Size, St);
      WtoS:= St;
   end;


function StoW;
   var I: Integer;
       W: Word;

   begin
      Val( S, W, I);
      StoW:= W;
   end;


function LtoS;
   var St: String;

   begin
      Str( L:Size, St);
      LtoS:= St;
   end;


function StoL;
   var I: Integer;
       L: LongInt;

   begin
      Val( S, L, I);
      StoL:= L;
   end;



                { ***  RAM  TOOLS  *** }


function IsEqual( var Buf1, Buf2; Count: Word): Boolean; assembler;
   asm
            mov     ax,1            { assume True }
            mov     cx,Count
            jcxz    @@Quit
            push    ds
            les     di,Buf1
            lds     si,Buf2
            cld
            repe    cmpsb
            je      @@Done
            dec     ax              { return False }
@@Done:
            pop     ds
@@Quit:
   end;


function Compare( var Buf1, Buf2; Count: Word): Integer; assembler;
   asm
            xor     ax,ax            { assume Buf2=Buf1 }
            mov     cx,Count
            jcxz    @@Quit
            push    ds
            les     di,Buf2
            lds     si,Buf1
            cld
            repe    cmpsb
            je      @@Done
            jb      @@Below
            mov     al,2            { Buf1>Buf2 }
@@Below:
            dec     ax              { Buf1<Buf2 }
@@Done:
            pop     ds
@@Quit:
   end;



               { ***   MIN & MAX  TOOLS   *** }


function MaxByte( B1, B2: Byte): Byte; assembler;
   asm
            mov     al,B1
            mov     ah,B2
            cmp     al,ah
            jae     @@Done
            mov     al,ah
@@Done:
   end;


function MaxWord( W1, W2: Word): Word; assembler;
   asm
            mov     ax,W1
            mov     dx,W2
            cmp     ax,dx
            jae     @@Done
            mov     ax,dx
@@Done:
   end;


function MaxInt( I1, I2: Integer): Integer; assembler;
   asm
            mov     ax,I1
            mov     dx,I2
            cmp     ax,dx
            jge     @@Done
            mov     ax,dx
@@Done:
   end;


function MinByte( B1, B2: Byte): Byte; assembler;
   asm
            mov     al,B1
            mov     ah,B2
            cmp     al,ah
            jbe     @@Done
            mov     al,ah
@@Done:
   end;


function MinWord( W1, W2: Word): Word; assembler;
   asm
            mov     ax,W1
            mov     dx,W2
            cmp     ax,dx
            jbe     @@Done
            mov     ax,dx
@@Done:
   end;


function MinInt( I1, I2: Integer): Integer; assembler;
   asm
            mov     ax,I1
            mov     dx,I2
            cmp     ax,dx
            jle     @@Done
            mov     ax,dx
@@Done:
   end;


end.
